ALTER TABLE NSTANJE
ADD PORTAL VARCHAR2(1 CHAR);

ALTER TABLE NOTIFICATION_TEMPLATE
ADD ID_TIMER_DATA NUMBER;

ALTER TABLE NOTIFICATION_TEMPLATE
ADD CONSTRAINT NOT_TEMPLATE_ID_TIMER_DATA_FK
FOREIGN KEY (ID_TIMER_DATA)
REFERENCES TIMER_DATA(ID_TIMER_DATA);

DROP VIEW V_PREGLEDI;

CREATE OR REPLACE VIEW V_PREGLEDI AS (
  SELECT P.ID_PREGLEDI, P.ID_LASTNIKA, P.ID_PLOVILA, P.NSTANJE, P.DATUM, P.CAS, P.KOMENTAR, P.KOMENTAR1, P.DATUM_KREIRANJA, P.USER_KREIRANJA, P.LASTNIK_OBVESCEN, P.N_PRIVEZA, P.OBJEKT, P.ID_PRIVEZ, P.ID_STORITVE, P.STATUS,
  PL.IME AS PLOVILA_IME, NS.OPIS AS NSTANJE_OPIS, NS.INTERNI_OPIS AS NSTANJE_INTERNI_OPIS, NS.NSTANJE_TYPE AS NSTANJE_TYPE, NS.PORTAL AS NSTANJE_PORTAL, NNP.NNLOCATION_ID, KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK,
  (CASE WHEN P.ID_PRIVEZ IS NOT NULL THEN NP.OBJEKT ELSE P.OBJEKT END) AS NNPRIVEZ_OBJEKT, (CASE WHEN P.ID_PRIVEZ IS NOT NULL THEN NP.N_PRIVEZA ELSE P.N_PRIVEZA END) AS NNPRIVEZ_PRIVEZ,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KU.IME || ' ' || KU.PRIIMEK) ELSE (KU.PRIIMEK || ' ' || KU.IME) END) AS OWNER
	FROM PREGLEDI P
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = P.ID_PLOVILA
  LEFT OUTER JOIN KUPCI KU ON KU.ID = P.ID_LASTNIKA
  LEFT OUTER JOIN NSTANJE NS ON NS.NSTANJE = P.NSTANJE
  LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = P.ID_PRIVEZ
  LEFT OUTER JOIN NNPOMOL NNP ON NNP.SIFRA = NP.KATEGORIJA
);

DROP VIEW V_NOTIFICATION_TEMPLATE;

CREATE OR REPLACE VIEW V_NOTIFICATION_TEMPLATE AS
SELECT NT.ID_NOTIFICATION_TEMPLATE, NT.NAME, NT.VALUE, NT.RECEIVER, NT.TITLE, NT.CONTENT, NT.TYPE, NT.NNLOCATION_ID, NT.USER_SELECTABLE, 
NT.DATE_CHANGED, NT.USER_CHANGED, NT.DATE_CREATED, NT.USER_CREATED, NT.ACTIVE, NT.ID_TIMER_DATA,
NTT.DESCRIPTION AS TYPE_DESCRIPTION, NTT.INTERNAL_DESCRIPTION AS TYPE_INTERNAL_DESCRIPTION
FROM NOTIFICATION_TEMPLATE NT
LEFT OUTER JOIN NOTIFICATION_TEMPLATE_TYPE NTT ON NT.TYPE = NTT.CODE;

DROP VIEW V_SMS_TEMPLATE;

CREATE OR REPLACE VIEW V_SMS_TEMPLATE AS
SELECT ST.ID_SMS_TEMPLATE, ST.NAME, ST.VALUE, ST.RECEIVER, ST.CONTENT, ST.TYPE, ST.NNLOCATION_ID, ST.USER_SELECTABLE, ST.DATE_CHANGED, ST.USER_CHANGED, 
ST.DATE_CREATED, ST.USER_CREATED, ST.ACT, ST.ID_TIMER_DATA,
STT.OPIS AS TYPE_OPIS, STT.INTERNI_OPIS AS TYPE_INTERNI_OPIS
FROM SMS_TEMPLATE ST
LEFT OUTER JOIN NNSMS_TEMPLATE_TYPE STT ON ST.TYPE = STT.SIFRA;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2183, SYSDATE, '5.5', 2103, 'Pregledi')
;
