-- Popravek pogleda V_REZERVAC, dodana stolpca POGODBA_OBJEKT in pa POGODBA_N_PRIVEZA
CREATE OR REPLACE VIEW V_REZERVAC AS (
  SELECT R.ID, D.ID_REZERVAC_DETAIL, R.ID_POGODBE, D.DATUM_OD AS DATUM_REZERVACIJE, D.DATUM_DO,
  NP.OBJEKT AS NOBJEKT, NP.N_PRIVEZA AS PRIVEZ, D.ID_PRIVEZ, R.VRSTA, D.STATUS_REZERVAC, R.ID_LASTNIKA, R.ID_PLOVILA, NNO.OBJECT_TYPE, 
  MP.OBJEKT AS POGODBA_OBJEKT, MP.N_PRIVEZA AS POGODBA_N_PRIVEZA,
  (CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.NAZIV ELSE K.PRIIMEK END) AS NAZIV,
  (CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.PRIIMEK ELSE K.PRIIMEK END) AS PRIIMEK,
  (CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.IME ELSE K.IME END) AS IME, K.SALDAKONTI_SIT,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.PLOVILO ELSE P.IME END) AS PLOVILO,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.DOLZINA ELSE P.DOLZINA END) AS DOLZINA,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.SIRINA ELSE P.SIRINA END) AS SIRINA,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.GREZ ELSE P.GREZ END) AS GREZ,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.NTIP ELSE P.NTIP END) AS NTIP,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.OPIS ELSE NT.OPIS END) AS TIP_PLOVILA_LONG,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.NNTIP_TYPE ELSE NT.NNTIP_TYPE END) AS NNTIP_TYPE,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.REGISTRSKA_N END) AS REGISTRSKA_N,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.NZASTAVA END) AS NZASTAVA,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE ND.OPIS END) AS NZASTAVA_LONG,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.BARVA ELSE NT.BARVA END) AS BARVA,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_TOP ELSE NT.SVG_OBLIKA_TOP END) AS SVG_OBLIKA_TOP,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_FRONT ELSE NT.SVG_OBLIKA_FRONT END) AS SVG_OBLIKA_FRONT
  FROM REZERVAC R
  JOIN REZERVAC_DETAIL D ON R.ID=D.ID_REZERVAC
  LEFT OUTER JOIN NNPRIVEZ NP ON D.ID_PRIVEZ=NP.ID_PRIVEZ
  LEFT OUTER JOIN KUPCI K ON K.ID = R.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA P ON P.ID = R.ID_PLOVILA
  LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
  LEFT OUTER JOIN NNTIP NTR ON NTR.SIFRA = R.NTIP
  LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = P.NZASTAVA
  LEFT OUTER JOIN NNOBJEKT NNO ON NNO.SIFRA = NP.OBJEKT
  LEFT OUTER JOIN M_POGODBE MP ON MP.ID_POGODBE = R.ID_POGODBE
  WHERE R.STORNO IS NULL AND R.DATUM_DO IS NOT NULL
);

-- Popravek pogleda V_REZERVAC_SVG, dodani N_PRIVEZA, POGODBA_OBJEKT, POGODBA_N_PRIVEZA, TIP_PLOVILA_LONG, REGISTRSKA_N, NZASTAVA, NZASTAVA_LONG
CREATE OR REPLACE VIEW V_REZERVAC_SVG AS (
	SELECT DISTINCT V.ID, V.ID_REZERVAC_DETAIL, V.ID_POGODBE, V.DATUM_REZERVACIJE, V.DATUM_DO, V.NOBJEKT, V.PRIVEZ, V.ID_LASTNIKA, V.ID_PLOVILA, V.ID_PRIVEZ, V.PRIIMEK AS PRIIMEK_LASTNIKA, V.IME AS IME_LASTNIKA,
	V.PLOVILO AS IME_PLOVILA, V.NTIP AS TIP_PLOVILA, V.DOLZINA AS DOLZINA_PLOVILA, V.SIRINA AS SIRINA_PLOVILA, RD.TRANS_X AS TRANS_X_PLOVILA, RD.TRANS_Y AS TRANS_Y_PLOVILA,
	RD.ROT_DEGREES AS ROT_DEGREES_PLOVILA, NS.DOLZINA AS DOLZINA_PRIVEZA, NS.SIRINA AS SIRINA_PRIVEZA, NS.TRANS_X AS TRANS_X_PRIVEZA, NS.TRANS_Y AS TRANS_Y_PRIVEZA, NS.ROT_DEGREES AS ROT_DEGREES_PRIVEZA, N.OBJEKT, N.N_PRIVEZA,
	V.VRSTA AS VRSTA_REZERVACIJE, V.STATUS_REZERVAC AS STATUS_REZERVACIJE, V.OBJECT_TYPE, V.POGODBA_OBJEKT, V.POGODBA_N_PRIVEZA, V.TIP_PLOVILA_LONG, V.NNTIP_TYPE, V.REGISTRSKA_N, V.NZASTAVA, V.NZASTAVA_LONG, V.BARVA, V.SVG_OBLIKA_TOP, V.SVG_OBLIKA_FRONT 
	FROM V_REZERVAC V
	JOIN NNPRIVEZ N ON N.ID_PRIVEZ = V.ID_PRIVEZ
	JOIN NNPRIVEZ_SVG NS ON NS.ID_PRIVEZ = V.ID_PRIVEZ
	LEFT JOIN REZERVAC_DETAIL_SVG RD ON RD.ID_REZERVAC_DETAIL = V.ID_REZERVAC_DETAIL
);

insert into verzije_baza (id, dt_vpis, verzija, ver_nr, opis) 
values 
(404, SYSDATE, '5.5', 324, 'V_REZERVAC in V_REZERVAC_SVG razsiritev');