CREATE OR REPLACE VIEW V_KUPCI_PLOVILA AS (
  SELECT CONCAT(CONCAT(K.ID, '-'), P.ID) AS KUPCI_PLOVILA_ID, K.ID AS ID_LASTNIKA, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.NASLOV AS KUPCI_NASLOV, K.MESTO AS KUPCI_MESTO, K.POSTA AS KUPCI_POSTA, K.VRSTA AS KUPCI_VRSTA,
  K.NDRZAVA AS KUPCI_NDRZAVA, K.EMAIL AS KUPCI_EMAIL, K.TELEFON_1 AS KUPCI_TELEFON_1, K.YACHT_CLUB_ID, K.ID_MEMBER AS KUPCI_ID_MEMBER, P.ID AS PLOVILA_ID, P.IME AS PLOVILA_IME, P.REGISTRSKA_N AS PLOVILA_REGISTRSKA_N, P.MODEL AS PLOVILA_MODEL,
  P.NTIP AS PLOVILA_NTIP, P.NZASTAVA AS PLOVILA_NZASTAVA, P.TRENUTNI_OBJEKT_PRIVEZA, P.TRENUTNA_N_PRIVEZA, P.TRENUTNO_DO, P.POGODBENI_OBJEKT_PRIVEZA, P.POGODBENA_N_PRIVEZA, P.POGODBA_DO, P.DOLZINA AS PLOVILA_DOLZINA,
  P.SIRINA AS PLOVILA_SIRINA, P.GREZ AS PLOVILA_GREZ, P.BOOKING AS PLOVILA_BOOKING, VPT.ID_PRIVEZ AS ID_PRIVEZ_TEMP, VPT.NNLOCATION_ID AS ID_LOCATION_TEMP, VPC.ID_PRIVEZ AS ID_PRIVEZ_CONTRACT, VPC.NNLOCATION_ID AS ID_LOCATION_CONTRACT
  FROM KUPCI K
  LEFT OUTER JOIN PLOVILA P ON P.ID_LASTNIKA = K.ID
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VPT ON VPT.OBJEKT = P.TRENUTNI_OBJEKT_PRIVEZA AND VPT.N_PRIVEZA = P.TRENUTNA_N_PRIVEZA
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VPC ON VPC.OBJEKT = P.POGODBENI_OBJEKT_PRIVEZA AND VPC.N_PRIVEZA = P.POGODBENA_N_PRIVEZA
);


CREATE OR REPLACE VIEW V_RESERVATIONS_MANAGEMENT AS 
(
SELECT 'ALARM_ARRIVAL' AS CATEGORY, CONCAT('ALARM_ARRIVAL', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.STATUS_REZERVAC, RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_REZERVACIJE) < TRUNC(SYSDATE) AND RE.STATUS_REZERVAC > 2 AND NOT EXISTS 
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE < RE.DATUM_REZERVACIJE AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC IN (1,2) )

UNION ALL

SELECT 'ALARM_DEPARTURE' AS CATEGORY, CONCAT('ALARM_DEPARTURE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.STATUS_REZERVAC, RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_DO) <= TRUNC(SYSDATE) AND RE.STATUS_REZERVAC IN (1,2) AND NOT EXISTS 
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE = RE.DATUM_DO AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC > 0)

UNION ALL

SELECT 'ALARM_MOVE' AS CATEGORY, CONCAT('ALARM_MOVE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE='Y')

UNION ALL

SELECT 'ALARM_EXIT' AS CATEGORY, CONCAT('ALARM_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.STATUS_REZERVAC = 2 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE='Y')

UNION ALL

SELECT 'ALARM_RETURN' AS CATEGORY, CONCAT('ALARM_RETURN', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 2 AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2 AND DE2.COMPLETE='Y')

UNION ALL

SELECT 'PLAN_ARRIVAL' AS CATEGORY, CONCAT('PLAN_ARRIVAL', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.STATUS_REZERVAC, RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_REZERVACIJE) >= TRUNC(SYSDATE) AND RE.STATUS_REZERVAC > 2 AND NOT EXISTS 
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE < RE.DATUM_REZERVACIJE AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC IN (1,2) )

UNION ALL

SELECT 'PLAN_DEPARTURE' AS CATEGORY, CONCAT('PLAN_DEPARTURE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.STATUS_REZERVAC, RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_DO) > TRUNC(SYSDATE) AND RE.STATUS_REZERVAC IN (1,2) AND NOT EXISTS 
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE = RE.DATUM_DO AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC > 0)

UNION ALL

SELECT 'PLAN_MOVE' AS CATEGORY, CONCAT('PLAN_MOVE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND NOT EXISTS 
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2)

UNION ALL

SELECT 'PLAN_EXIT' AS CATEGORY, CONCAT('PLAN_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 2 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N')

UNION ALL

SELECT 'PLAN_RETURN' AS CATEGORY, CONCAT('PLAN_RETURN', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND EXISTS 
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2)

UNION ALL

SELECT 'CURRENT_PRESENT' AS CATEGORY, CONCAT('CURRENT_PRESENT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.DATUM_OD = (SELECT MAX(DE2.DATUM_OD) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE = 'Y')

UNION ALL

SELECT 'CURRENT_EXIT' AS CATEGORY, CONCAT('CURRENT_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 2 AND DE.DATUM_OD = (SELECT MAX(DE2.DATUM_OD) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.STATUS_REZERVAC = 2 AND DE2.COMPLETE = 'Y')
)
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (623, SYSDATE, '5.5', 543, 'Lokacije');