CREATE TABLE SMS (
	ID NUMBER,
	RECEIVER VARCHAR2(250 CHAR),
	CONTENT VARCHAR2(500 CHAR),
	STATUS NUMBER,
	SMS_FILE VARCHAR2(100 CHAR),
	DATE_CREATED DATE,
	USER_CREATED VARCHAR2(100 CHAR),
	CONSTRAINT SMS_PK PRIMARY KEY (ID)
);

CREATE SEQUENCE SMS_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

ALTER TABLE OPOMINI
ADD ID_SMS NUMBER;

CREATE TABLE NNSMS_STATUS (
	SIFRA NUMBER NOT NULL,
	OPIS VARCHAR2(100 CHAR),
	INTERNI_OPIS VARCHAR2(100 CHAR),
	AKT VARCHAR2 (1 CHAR),
	CONSTRAINT NNSMS_STATUS_PK PRIMARY KEY (SIFRA)
);

INSERT INTO NNSMS_STATUS(SIFRA, OPIS, INTERNI_OPIS, AKT) VALUES
(0, 'Not yet sent', 'Not yet sent', 'Y');

INSERT INTO NNSMS_STATUS(SIFRA, OPIS, INTERNI_OPIS, AKT) VALUES
(1, 'Successfully sent', 'Successfully sent', 'Y');


CREATE OR REPLACE VIEW V_SMS
AS (
SELECT S.ID, S.RECEIVER, S.CONTENT, S.STATUS, S.SMS_FILE, S.DATE_CREATED, S.USER_CREATED, 
K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK
FROM SMS S
LEFT OUTER JOIN (SELECT ID_KUPCA, ID_SMS, NPISMO, RANK() OVER (PARTITION BY ID_SMS ORDER BY ID_OPOMINI ASC) RNK FROM OPOMINI) O ON (O.ID_SMS = S.ID AND O.RNK = 1 AND O.NPISMO = 'S')
LEFT OUTER JOIN KUPCI K ON O.ID_KUPCA = K.ID
);


insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (724, SYSDATE, '5.5', 644, 'Sms');